package de.jave.eclipse.copyfully.ui;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.internal.ui.actions.SelectionConverter;
import org.eclipse.jdt.internal.ui.javaeditor.JavaEditor;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;

/**
 * @author Markus Gebhard
 */
public class CopyFullyQualifiedClassNameEditorAction
    extends
    AbstractCopyFullyQualifiedClassNameAction implements IEditorActionDelegate {

  private JavaEditor javaEditor;

  public final void selectionChanged(IAction action, ISelection selection) {
    //nothing to do
  }

  public final void setActiveEditor(IAction action, IEditorPart targetEditor) {
    if (targetEditor instanceof JavaEditor) {
      javaEditor = (JavaEditor) targetEditor;
    } else {
      javaEditor = null;
    }
    setActivePart(targetEditor);
  }

  protected final Object getSelectedObject() throws JavaModelException {
    IJavaElement element = SelectionConverter.codeResolve(
        javaEditor,
        getShell(),
        Messages.getString("CopyFullyQualifiedClassNameAction.dialog.select.title"), //$NON-NLS-1$
        (Messages.getString("CopyFullyQualifiedClassNameAction.dialog.select.message"))); //$NON-NLS-1$
    if (element == null) {
      element = SelectionConverter.getInput(javaEditor);
    }
    return element;
  }
}